Panda3D

Loading...
Searching...
No Matches
Public Member Functions | List of all members
FltRecordWriter Class Reference

This class writes a sequence of FltRecords to an ostream, handling opcode and size counts properly. More...

`#include "fltRecordWriter.h"`

## Public Member Functions
| FltRecordWriter (std::ostream &out)
FltError | advance ()
| Writes the current record to the flt file, and resets the current record to receive new data.
const Datagram & | get_datagram () const
void | set_datagram (const Datagram &datagram)
| Sets the datagram that will be written when advance() is called.
void | set_opcode (FltOpcode opcode)
| Sets the opcode associated with the current record.
Datagram & | update_datagram ()
| Returns a modifiable reference to the datagram associated with the current record.
FltError | write_instance_def (FltHeader *header, int instance_index)
| Ensures that the given instance definition has already been written to the file.
FltError | write_record (FltOpcode opcode, const Datagram &datagram=Datagram())
| A convenience function to quickly write a simple record that consists of an opcode and possibly a datagram.

## Detailed Description

This class writes a sequence of FltRecords to an ostream, handling opcode and size counts properly.

Definition at line 31 of file fltRecordWriter.h.

## Constructor & Destructor Documentation

## ◆ FltRecordWriter()

FltRecordWriter::FltRecordWriter | ( | std::ostream & | out | ) |

Definition at line 30 of file fltRecordWriter.cxx.

## ◆ ~FltRecordWriter()

FltRecordWriter::~FltRecordWriter | ( |  | ) |

Definition at line 39 of file fltRecordWriter.cxx.

## Member Function Documentation

## ◆ advance()

FltError FltRecordWriter::advance | ( |  | ) |

Writes the current record to the flt file, and resets the current record to receive new data.

Returns FE_ok on success, or something else on error.

Definition at line 74 of file fltRecordWriter.cxx.

References Datagram::add_be_int16(), Datagram::get_data(), and Datagram::get_length().

Referenced by write_record().

## ◆ set_datagram()

void FltRecordWriter::set_datagram | ( | const Datagram & | datagram | ) |

Sets the datagram that will be written when advance() is called.

Definition at line 54 of file fltRecordWriter.cxx.

## ◆ set_opcode()

void FltRecordWriter::set_opcode | ( | FltOpcode | opcode | ) |

Sets the opcode associated with the current record.

Definition at line 46 of file fltRecordWriter.cxx.

Referenced by FltLocalVertexPool::build_record().

## ◆ update_datagram()

Datagram & FltRecordWriter::update_datagram | ( |  | ) |

Returns a modifiable reference to the datagram associated with the current record.

This datagram should then be stuffed with data corresponding to the data in the record, in preparation for calling advance() to write the data.

Definition at line 65 of file fltRecordWriter.cxx.

Referenced by FltLocalVertexPool::build_record().

## ◆ write_instance_def()

FltError FltRecordWriter::write_instance_def | ( | FltHeader * | header,
|  | int | instance_index )

Ensures that the given instance definition has already been written to the file.

If it has not, writes it now.

Definition at line 135 of file fltRecordWriter.cxx.

References FltHeader::get_instance().

## ◆ write_record()

FltError FltRecordWriter::write_record | ( | FltOpcode | opcode,
|  | const Datagram & | datagram = Datagram() )

A convenience function to quickly write a simple record that consists of an opcode and possibly a datagram.

Definition at line 124 of file fltRecordWriter.cxx.

References advance().

The documentation for this class was generated from the following files:

- pandatool/src/flt/fltRecordWriter.h
- pandatool/src/flt/fltRecordWriter.cxx